---
title: ReadableStream.cancel()
slug: Web/API/ReadableStream/cancel
tags:
  - API
  - Method
  - ReadableStream
  - Reference
  - Streams
  - cancel
---
<div>{{APIRef("Streams")}}</div>

<p class="summary">The <strong><code>cancel()</code></strong> method of the {{domxref("ReadableStream")}} interface cancels the associated stream. The supplied <code>reason</code> parameter will be given to the underlying source, which may or may not use it.</p>

<p>Cancel is used when you've completely finished with the stream and don't need any more data from it, even if there are chunks enqueued waiting to be read. That data is lost after cancel is called, and the stream is not readable any more. To read those chunks still and not completely get rid of the stream, you'd use {{domxref("ReadableStreamDefaultController.close()")}}.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>promise</em> = <em>readableStream</em>.cancel(<em>reason</em>);</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>reason</dt>
 <dd>A {{domxref("DOMString")}} providing a human-readable reason for the cancellation.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Promise")}}, which fulfills with the value given in the <code>reason</code> parameter.</p>

<h3 id="Exceptions">Exceptions</h3>

<dl>
 <dt>TypeError</dt>
 <dd>The stream you are trying to cancel is not a {{domxref("ReadableStream")}}, or it is locked.</dd>
</dl>

<h2 id="Examples">Examples</h2>

<p>In Jake Archibald's <a href="https://jsbin.com/gameboy/edit?js,console">cancelling a fetch</a> example, a stream is used to fetch the WHATWG HTML spec chunk by chunk; each chunk is searched for the string "service workers". When the search terms is found, <code>cancel()</code> is used to cancel the stream — the job is finished so it is no longer needed.</p>

<pre class="brush: js">var searchTerm = "service workers";
// Chars to show either side of the result in the match
var contextBefore = 30;
var contextAfter = 30;
var caseInsensitive = true;
var url = 'https://html.spec.whatwg.org/';

console.log(`Searching '${url}' for '${searchTerm}'`);

fetch(url).then(response =&gt; {
  console.log('Received headers');

  var decoder = new TextDecoder();
  var reader = response.body.getReader();
  var toMatch = caseInsensitive ? searchTerm.toLowerCase() : searchTerm;
  var bufferSize = Math.max(toMatch.length - 1, contextBefore);

  var bytesReceived = 0;
  var buffer = '';
  var matchFoundAt = -1;

  return reader.read().then(function process(result) {
    if (result.done) {
      console.log('Failed to find match');
      return;
    }

    bytesReceived += result.value.length;
    console.log(`Received ${bytesReceived} bytes of data so far`);

    buffer += decoder.decode(result.value, {stream: true});

    // already found match &amp; just context-gathering?
    if (matchFoundAt === -1) {
      matchFoundAt = (caseInsensitive ? buffer.toLowerCase() : buffer).indexOf(toMatch);
    }

    if (matchFoundAt === -1) {
      buffer = buffer.slice(-bufferSize);
    }
    else if (buffer.slice(matchFoundAt + toMatch.length).length &gt;= contextAfter) {
      console.log("Here's the match:")
      console.log(buffer.slice(
        Math.max(0, matchFoundAt - contextBefore),
        matchFoundAt + toMatch.length + contextAfter
      ));
      console.log("Cancelling fetch");
      reader.cancel();
      return;
    }
    else {
      console.log('Found match, but need more context…');
    }

    // keep reading
    return reader.read().then(process);
  });
}).catch(err =&gt; {
  console.log("Something went wrong. See devtools for details. Does the response lack CORS headers?");
  throw err;
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName("Streams","#rs-cancel","cancel()")}}</td>
   <td>{{Spec2('Streams')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div class="hidden">
<p>The compatibility table on this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>
</div>

<p>{{Compat("api.ReadableStream.cancel")}}</p>
